NB. built from project: ~Classes\graphics\gnuplotdemo\gnuplotdemo
NB. gpdemo.ijs  - gnuplot examples


load 'numeric trig'
load '~system\packages\graphics\gnuplot.ijs'

NB. SC is sin(exp(x)) ; cos(exp(x))
SC=: ((,.sin@^);(,.cos@^))"_ [ 0.05*_20+i.60

NB. plot SC, with grid title and labels:
gp1=: 3 : 0
set 'grid'
set 'title "sin(exp) vs cos(exp)"'
set 'xlabel "x-axis"'
set 'ylabel "y-axis"'
'title "sin(exp)", title "cos(exp)"' plot SC
)

wiggle=. 3    NB. try 4
points=. 91   NB. increase for smoothness
cos=.    2&o.
X=.      (3 % <:points) * i.points
fn=.     +/@((0.9&^) * cos@((3&^ * (+/&X))))@i.
XY=:      fn wiggle

gp2=: 3 : 0
plot XY
)

x=. range _3 3 0.2
y=. range _3 3 0.2
CP=: (x ,"0/ y),"1 0 sin x +/ sin y

gp3=: 3 : 0
set 'title "sin(x+sin(y))"'
set 'parametric'
splot CP
)

NB.
x=. range _3 3 0.2
y=. range _3 3 0.2
SP=: (x ,"0/ y),"1 0 (sin x) */ sin y

gp4=: 3 : 0
set 'title "sin(x)*sin(y)) contour plot"'
set 'parametric;contour;cntrparam levels 15;view 0,0,1;nosurface'
splot SP
)

