NB. Plot viewer

plotrun=: 0!:100
plotruns=: 0!:100 @ ".

PLTIMER=: 3000
IFWINCE=: 7=9!:12''
PLDEMOVER=: 1.2
PLDEMOSEL=: 'JGRAPHICS'
SLIDES=: 0

PLOTDEMO=: 0 : 0
pc plotdemo closeok;pn "J Graphics";
menupop "&Options";
menu view "&View Definition" "" "" "";
menusep ;
menu clip "&Clip" "" "" "";
menusep ;
menu print "&Print" "" "" "";
menusep ;
menu slides "&Slide Show" "" "" "";
menusep ;
menu exit "E&xit" "" "" "";
menupopz;
menupop "&Styles";
menu MJGRAPHICS "J Graphics" "" "" "";
menusep ;
menu MLINE "Line" "" "" "";
menu MLINES "Line Sampler" "" "" "";
menu MLINESTYLE "Line Options" "" "" "";
menu MLINEPATTERN "Line Patterns" "" "" "";
menusep ;
menu MAREA "Area" "" "" "";
menu MDOT "Dot" "" "" "";
menu MPOINT "Point" "" "" "";
menu MPOLAR "Polar" "" "" "";
menu MSTICK "Stick" "" "" "";
menusep ;
menu MBAR "Bar" "" "" "";
menu MBARS "Bar Sampler" "" "" "";
menusep ;
menu MERRORBAR "Error Bar" "" "" "";
menu MHILO "HiLo" "" "" "";
menusep ;
menu MPIE "Pie" "" "" "";
menu MRADAR "Radar" "" "" "";
menusep ;
menu MDENSITY "Density" "" "" "";
menupopz;
menupop "&3D";
menu MLINE3D "3D Line" "" "" "";
menu MSTICK3D "3D Stick" "" "" "";
menu MWIRE "Wire" "" "" "";
menusep ;
menu MSURFACE "Surface" "" "" "";
menu MSURFACEREV "Surface of Revolution" "" "" "";
menusep ;
menu MSURFACES "Surface Sampler" "" "" "";
menupopz;
menupop "&Gallery";
menu MLINE1 "Line 1" "" "" "";
menu MLINE2 "Line 2" "" "" "";
menu MLINE3 "Line 3" "" "" "";
menu MLINE4 "Line 4" "" "" "";
menusep ;
menu MCURVEFIT "Curve Fitting" "" "" "";
menu MLEGENDRE "Legendre" "" "" "";
menu MPRIMERACE "Prime Race" "" "" "";
menusep ;
menu MPAT1 "Patterns 1" "" "" "";
menu MPAT2 "Patterns 2" "" "" "";
menusep ;
menu MPOLY "Poly" "" "" "";
menusep ;
menu MWIRES "Wire" "" "" "";
menu MGAMMA "Gamma Function" "" "" "";
menu MDRUM "Drum" "" "" "";
menu MSURFACE1 "Surface" "" "" "";
menupopz;
menupop "S&hapes";
menu MSPHERE "Sphere" "" "" "";
menusep ;
menu MSOLID "Solids" "" "" "";
menu MSTELLATE "Stellates" "" "" "";
menupopz;
menupop "&Help";
menu next "&F12 Next" "" "" "";
menu prev "&Shift F12 Previous" "" "" "";
menusep ;
menu about "&About" "" "" "";
menupopz;
xywh 0 0 270 180;cc ps isigraph rightmove bottommove;
pas 0 0;pcenter;ptop;
rem form end;
)

plotdemo_run=: 3 : 0
pd_reset ''
ASPECT=: 170%270
IfVGA=: 640>:{.0".wd 'qm'
PShow=: 0
wd PLOTDEMO
PForm=: 'plotdemo'
PFormhwnd=: wd 'qhwndp'
PId=: 'ps'
PShow=: 1
wd 'set M',PLDEMOSEL,' 1'
glbrush glrgb GRAY
glrect 0 0 1000 1000

NB. nonce, hard code CE form:
if. IFWINCE do.
  wd 'pmovex 220 -23 400 260'
  wd 'setenable clip 0'
  wd 'setenable print 0'
  wd 'setenable slides 0'
end.

plotruns 'D',PLDEMOSEL
)

plotdemo_default=: 3 : 0
if. systype -: 'button' do.
  name=. }.syschild
  if. name -: PLDEMOSEL do.
    wd 'set M',PLDEMOSEL,' 1'
    return.
  end.
  if. (<name) e. PLOTNAMES do.
    wd 'set M',PLDEMOSEL,' 0'
    PLDEMOSEL=: name
    wd 'set M',PLDEMOSEL,' 1'
    pd_reset 'plotdemo'
    wd 'pshow'
    plotruns 'D',PLDEMOSEL
  end.
end.
''
)

plotdemo_view_button=: 3 : 0
gedit_run PLDEMOSEL
)

plotdemo_exit_button=: 3 : 0
wd 'psel plotdemo;pclose;'
try. wd 'psel gedit;pclose' catch. end.
)

plotdemo_contents_button=: 3 : 0
wdinfo 'help contents'
)

plotdemo_about_button=: 3 : 0
j=. 'J Graphics Demo V',(4.2 ": PLDEMOVER)
wdinfo 'J Graphics';j
)

plotdemo_print_button=: 3 : 0
temp=. jpath '~temp\t1.wmf'
glfile temp
glsave 1 0 0
wd 'pc print;cc g0 isigraph'
glzcreate''
glzstartdoc 'print'
glzmap MM_TWIPS
glzdevmode 'orientation 2'
glzstartpage''
size=. 1440 * %/ (2 3 ,: 4 5) { glqprinter''
glplayxywh 0 0 ,size
glplay temp
glshow''
glzprint''
glzendpage''
glzenddoc''
wd 'pclose'
)

plotdemo_clip_button=: 3 : 0
glfile ''
glsave 1 10000 7500
)



plotdemo_slides_button=: 3 : 0
if. SLIDES do.
  wd 'timer 0'
  SLIDES=: 0
  erase 'sys_timer_z_'
else.
  wd 'timer ',":PLTIMER
  sys_timer_z_=: plotdemo_timer_jdplot_
  SLIDES=: 1
end.
wd 'set slides ',":SLIDES
)

plotdemo_timer=: 3 : 0
if. wdisparent 'plotdemo' do.
  wd 'psel plotdemo'
  plotdemo_next_button''
else.
  wd 'timer 0'
  SLIDES=: 0
  erase 'sys_timer_z_'
end.
)

plotdemo_step=: 3 : 0
ndx=. (#PLOTALL) | y. + PLOTALL i. <'D',PLDEMOSEL
wd 'set M',PLDEMOSEL,' 0'
PLDEMOSEL=: }.ndx pick PLOTALL
wd 'set M',PLDEMOSEL,' 1'
pd_reset 'plotdemo'
plotruns 'D',PLDEMOSEL
pshow''
)

plotdemo_ps_size=: pshow
plotdemo_next_button=: plotdemo_step bind  1
plotdemo_prev_button=: plotdemo_step bind _1
plotdemo_f12_fkey=: plotdemo_next_button
plotdemo_f12shift_fkey=: plotdemo_prev_button

plotdemo=: plotdemo_run
