NB. built from project: source\main\edit\edit

coclass 'jedit'


IFPALM211=: 1

IFWINCE=: IFWINCE
3 : 0 ''

if. IFWINCE do.
  fixpath=: ('\\'"_ -: 2&{.) }. ]
else.
  fixpath=: ]
end.

if. IFPALM211 do.
  jdir=: '\my documents\'&,
  PATHTEMP=: jdir 'jtemp\'
else.
  jdir=: jtemppath
  PATHTEMP=: jdir 'temp\'
end.

0
)
FILEPATH=: PATHTEMP
1!:5 :: ] < }: FILEPATH

FILENAME=: ''
FILETEXT=: ''
FILETYPES=: '"Scripts (*.ijs)|*.ijs|All Files (*.*)|*.*"'
IFSAVEOK=: 1
IFMAX=: 0
IFPTOP=: 0

WEDFONT=: FIXFONT
j=. 0 : 0
ctrl+e**close (save changes)
ctrl+m**maximize/restore
ctrl+n**new script
ctrl+o**open script
ctrl+q**quit (prompts to save)
ctrl+s**save
ctrl+shift+s*save as
ctrl+t**topmost on/off
ctrl+w**run script
ctrl+shift+w*run script with display
Esc**close (save changes)
)

WEDHELP=: TAB (bx j='*')} j
info=: wdinfo @ ('Edit'&;)

query=: 4 : 0
x. wdquery 'Edit';y.
)
fexist=: 1:@(1!:4)@boxopen ::0:
pathname=: ({. ; }.)~ (0: i.~ +./\.@(=&PATHSEP_j_))
pathonly=: {.~ (0: i.~ +./\.@(=&PATHSEP_j_))
fullname=: 3 : 0
if. PATHSEP_j_ ~: {.y.,PATHSEP_j_ do. jdir y. else. y. end.
)
openfile=: 3 : 0
j=. FILETYPES,' ofn_filemustexist ofn_nochangedir'
wd 'mbopen "Open File" "',FILEPATH,'" "" ',j
)
newtfile=: 3 : 0
d=. {."1 (1!:0) PATHTEMP,'*.ijs'
p=. (,&'.ijs') @ ": each >: i.1+#d
PATHTEMP,> {. p -. d
)
rplc=: 4 : 0
'o n'=. ,&.>y.
l=. #o
c=. o E. x=. ,x.
if. (0<l) *: 1 e. c do. x return. end.
bx=. #i.@#
c=. bx c
while. 0 e. d=. 1,<:/\(#o)<:(}.-}:)c
do. c=. d#c end.
p=. (i.#x) e. 0,c
x=. p <;.1 x
b=. o&-:@(l&$) &> x
f=. n&,@(l&}.) &.>
;(f b#x) (bx b) }x
)
saveasfile=: 3 : 0

fn=. tolower FILENAME, (0=#FILENAME)#jdir''

while. 1 do.
  'p f'=. pathname fn

  j=. FILETYPES,' ofn_nochangedir'
  fn=. wd 'mbsave "Save File" "',p,'" "',f,'" ',j

  if. -. '.' e. fn do. fn=. fn,'.ijs' end.

  if. fn -: FILENAME do. return. end.
  if. 0=fexist fn do. return. end.

  j=. fn,LF,'This file already exists.',LF,LF
  msg=. j,'Replace existing file?'

  if. 0=2 query msg do. fn return. end.
end.

)
wdmaximize=: 3 : 0
'fx fy zx zy yc ym sx sy sw sh'=. 6 }. 0 ". wd 'qm'
pos=. 0,(-fy+yc),(sw+fx),(sh+yc+2*fy)
wd 'pmovex ',":pos
)
wedclose=: 3 : 0
if. _1 ~: _1 ". (FILENAME i.'.') {. FILENAME do.
  select. 3 query 'Delete ',FILENAME,'?'
  case. 0 do. 1!:55 <FILENAME
  case. 1 do. wedsave 1
  case. 2 do. 0 return.
  end.
else.
  wedsave y.
end.
wd 'pclose'
1
)
wedsave=: 3 : 0
if. text-:FILETEXT do. return. end.
if. 0=IFSAVEOK do.
  if. 1=2 query 'Save changes to ',FILENAME,'?'
  do. return. end.
end.
(toHOST text) 1!:2 <FILENAME
FILETEXT=: text
IFSAVEOK=: 1
)

WED=: 0 : 0
pc wed;
menupop "File";
menu new "&New" "Ctrl+N" "" "";
menusep ;
menu open "&Open" "Ctrl+O" "" "";
menusep ;
menu save "&Save" "Ctrl+S" "" "";
menu saveas "S&ave As" "Ctrl+Shift+S" "" "";
menu saveend "Save and &Exit" "Ctrl+E" "" "";
menusep ;
menu quit "&Quit" "Ctrl+Q" "" "";
menupopz;
menupop "Run";
menu runwin "&Window" "Ctrl+W" "" "";
menu runwind "&Window Display" "Ctrl+Shift+W" "" "";
menupopz;
menupop "Options";
menu max "&Maximize" "Ctrl+M" "" "";
menusep ;
menu top "&Top" "Ctrl+T" "" "";
menupopz;
menupop "Help";
menu contents "&Contents" "" "" "";
menupopz;
xywh 0 0 200 110;cc text editm ws_vscroll es_autohscroll rightmove bottommove;
pas 0 0;
rem form end;
)
wed_run=: 3 : 0
wd WED
formhwnd=: wd 'qhwndp'
wd 'pn *J - [',FILENAME,']'
wd 'set text *',FILETEXT
wd 'setfont text ',WEDFONT
wdmove _1 0
wdfit 1 2
wd 'setfocus text'
wd 'pshow;'
)
create=: 3 : 0
if. 0 -: y. do.
  if. 0=#f=. openfile'' do.
    destroy'' return.
  end.
  FILENAME=: fixpath f
  FILETEXT=: toJ 1!:1 <FILENAME
  IFSAVEOK=: 0
elseif. 1 -: y. do.
  FILENAME=: fixpath newtfile''
  FILETEXT=: ''
  FILETEXT 1!:2 <FILENAME
  IFSAVEOK=: 1
elseif. do.
  FILENAME=: fixpath y.
  FILETEXT=: toJ 1!:1 <FILENAME
  IFSAVEOK=: 0
end.
FILENAME=: fixpath tolower FILENAME
FILEPATH=: pathonly FILENAME
wed_run''
)
destroy=: codestroy bind ''
formselect=: 3 : 'wd ''psel '',formhwnd'
wed_cancel=: wed_close=: destroy @ (wedclose bind 1)
wed_qctrl_fkey=: destroy @ (wedclose bind 0)
wed_fctrl_fkey=: 3 : 0
info 'f key - not yet'
)
wed_contents_button=: 3 : 0
info WEDHELP
)
wed_mctrl_fkey=: 3 : 0
if. IFMAX do.
  wd 'pmovex ',formx
else.
  formx=: wd 'qformx'
  wdmaximize''
end.
IFMAX=: -.IFMAX
wd 'set max ',":IFMAX
)

wed_octrl_fkey=: 3 : 0
try. fileopen_j_'' catch. end.
)
wed_nctrl_fkey=: 3 : 0
try. filenew_j_'' catch. end.
)
wed_sctrl_fkey=: 3 : 0
wedsave 1
)
wed_sctrlshift_fkey=: 3 : 0
if. #f=. saveasfile'' do.
  FILENAME=: fixpath tolower f
  FILEPATH=: pathonly FILENAME
  try. FILETEXT=: toJ 1!:1 <FILENAME
  catch. FILETEXT=: '' end.
  wedsave 1
  wd 'pn *J - [',FILENAME,']'
end.
)
wed_tctrl_fkey=: 3 : 0
wd 'ptop ',":IFPTOP=: -.IFPTOP
wd 'set top ',":IFPTOP
)
wed_wctrl_fkey=: 3 : 0
wedsave 0
smoutput '   load ''',FILENAME,''''
load FILENAME
)
wed_wctrlshift_fkey=: 3 : 0
wedsave 0
smoutput '   loadd ''',FILENAME,''''
loadd FILENAME
)
wed_new_button=: wed_nctrl_fkey
wed_open_button=: wed_octrl_fkey
wed_max_button=: wed_mctrl_fkey
wed_quit_button=: wed_qctrl_fkey
wed_runwin_button=: wed_wctrl_fkey
wed_runwind_button=: wed_wctrlshift_fkey
wed_save_button=: wed_sctrl_fkey
wed_saveas_button=: wed_sctrlshift_fkey
wed_saveend_button=: wed_close
wed_top_button=: wed_tctrl_fkey
