NB. built from project: ~Main\newuser\newuser
NB. newuser form


0!:0 <jpath '~system\main\text.ijs'
cocurrent 'jnewuser'
val=: 2;USERNAME=: USERJUL=: ''
0!:0 :: ] <jpath '~config\config.ijs'
0!:0 :: ] <jpath '~system\extras\util\jul.ijl'

3 : 0 ''
if. IFJAVA do.
  FONT=: 'sansserif 10'
  FONT2=: 'sansserif 16 bold'
else.
  FONT=: '"MS Sans Serif" 8'
  FONT2=: '"MS Sans Serif" 16 bold'
end.
)

NEWUSERHDR=: topara 0 : 0
If you are new to J, you might start by going through some of the Labs.
Then look at the Primer, which introduces the language and the working
environment, and at the various Demos.

The complete J documentation can be accessed through the Help menu.

All users should check out the Release Highlights.

We encourage you to join the J Forum, which is the main discussion group
for all topics related to J. For details, see: http://www.jsoftware.com
)

NEWUSERJUL=: topara 0 : 0
You need a J User License (JUL) to use J as a programmer.
Enter it in menu Edit|Configure|License.
This also enables the "Do not show this form again" checkbox.
)

NEWUSERWD=: 0 : 0
pc newuserwd nomax nosize;
xywh 8 5 232 15;cc w0 static ss_center;cn "";
xywh 8 20 232 77;cc g0 groupbox;cn "";
xywh 13 26 225 68;cc hdr static;cn "";
xywh 8 101 232 65;cc g1 groupbox;cn "Key Menu Items";
xywh 13 112 63 10;cc s0 static;cn "";
xywh 84 112 149 10;cc n0 static;cn "";
xywh 13 122 63 10;cc s1 static;cn "";
xywh 84 122 149 10;cc n1 static;cn "";
xywh 13 132 63 10;cc s2 static;cn "";
xywh 84 132 149 10;cc n2 static;cn "";
xywh 13 142 63 10;cc s3 static;cn "";
xywh 84 142 149 10;cc n3 static;cn "";
xywh 13 152 63 10;cc s4 static;cn "";
xywh 84 152 149 10;cc n4 static;cn "";
xywh 8 171 232 35;cc g2 groupbox;cn "User License";
xywh 13 180 225 25;cc s5 static;cn "";
xywh 8 212 173 11;cc show checkbox;cn "";
xywh 183 211 57 12;cc exitj button bs_defpushbutton;cn "E&xit to J Session";
pas 6 4;pcenter;
rem form end;
)

newsetfont=: 3 : 0
wd 'setfont ',y.,' ',FONT
)

newsetfont2=: 3 : 0
wd 'setfont ',y.,' ',FONT2
)

newuserwd_run=: 3 : 0
wd NEWUSERWD
wd 'set hdr *',NEWUSERHDR
ver=. (i.&'/' {. ])9!:14''
ver=. (({.ver) e. 'jJ') }. ver
j=. 'Welcome to J',ver
wd 'pn *',j
wd 'setcaption w0 *',j
newsetfont2 'w0'
newsetfont each ;:'hdr g0 g1 s0 s1 s2 s3 s4 s5 n0 n1 n2 n3 n4'

wd 'setcaption n0 *For new features and recent changes to the system'
wd 'setcaption s0 *Help|Release Highlights'
wd 'setcaption n1 *Information on the J User License'
wd 'setcaption s1 *Help|J User License'
wd 'setcaption n2 *To configure your system, e.g. change the fonts'
wd 'setcaption s2 *Edit|Configure...'
wd 'setcaption n3 *To run a Lab'
wd 'setcaption s3 *Studio|Labs...'
wd 'setcaption n4 *To run a Demo'
wd 'setcaption s4 *Studio|Demos...'

if. 0 pick val do.
 wd 'setcaption show *Do not show this form again (requires a JUL)'
 wd 'setcaption s5 *',NEWUSERJUL
 wd 'setenable show 0'
else.  
 wd 'setcaption show *Do not show this form again'
 exp=. 'Expiry: ', 1 pick val
 txt=. toJ 'Name: ',USERNAME,LF,'License: ',USERJUL,LF,exp
 wd 'setcaption s5 *',txt
end.

wd 'setfocus exitj'
wd 'pshow;'
)

newuserwd_close=: 3 : 0
if. ". show do.
  noshow ''
end.
wd 'pclose'
coerase <'jnewuser'
)

newuserwd_cancel=: newuserwd_enter=: newuserwd_close
newuserwd_exitj_button=: newuserwd_close
fexist=: 1!:4 :: 0:
fread=: 1!:1 :: 0:
fwrite=: 1!:2 :: 0:
noshow=: 3 : 0

cfl=. jpath '~config\config.ijs'

if. 0 -: fexist <cfl do.
  dat=. fread < jpath '~system\extras\config\stdcfg.ijs'
  dat fwrite <cfl
end.

dat=. fread <cfl
if. 0 -: dat do.
  msg=. 'Unable to save configuration file: ',cfl
  wdinfo 'New User';msg
  return.
end.

dat=. <;.2 dat , LF
ndx=. 1 i.~ (<'NEWUSER=') = 8 {.each dat
if. ndx = #dat do. dat=. dat , <'' end.
dat=. (<'NEWUSER=: 0',LF) ndx } dat
dat=. }: ; dat
dat fwrite <cfl

)

newuserwd_run''