NB. edit graph definition

getfontsize=: 13 : '{.1{._1 -.~ _1 ". y.'
setfontsize=: 4 : 0
b=. ~: /\ y.='"'
nam=. b#y.
txt=. ;:(-.b)#y.	
ndx=. 1 i.~ ([: *./ e.&'0123456789.') &> txt
nam, ; ,&' ' &.> (<fmt x.) ndx } txt
)

j=. FIXFONT
GEDFONT=: j,(0 e. #j)#'"Courier New" 10'
GEDFONTSZ=: getfontsize GEDFONT

GEDIT=: 0 : 0
pc gedit;
xywh 0 1 17 10;cc minus button;cn "&<<";
xywh 16 1 17 10;cc plus button;cn "&>>";
xywh 132 1 34 10;cc redisplay button leftmove rightmove;cn "&Redisplay";
xywh 166 1 34 10;cc close button leftmove rightmove;cn "&Close";
xywh 0 12 200 100;cc graf editm ws_vscroll rightmove bottommove;
pas 0 0;ptop;
rem form end;
)

NB. argument is name of definition
gedit_run=: 3 : 0
GFONTDEF=: PROFONT
if. 0=#GEDFONTSZ do.
  GEDFONTSZ=: (IFWINCE < IfVGA) { 12 9
end.
GNAME=: 'D',y.,(0=#y.)#'JGRAPHICS'
if. wdisparent 'gedit' do.
  wd 'psel gedit'
else.
  wd GEDIT
  wd 'setfont minus ',GFONTDEF
  wd 'setfont plus ',GFONTDEF
  wd 'setfont redisplay ',GFONTDEF
  wd 'setfont close ',GFONTDEF
  wd 'setfont graf ',GEDFONT
end.
wd 'set graf *',".GNAME
wd 'setfocus graf'
wd 'pshow;'
)

gedit_close_button=: 3 : 0
GRAF=: graf
GNAME assign graf
wd 'pclose'
)

gedit_close=: gedit_close_button

gedit_redisplay_button=: 3 : 0
GRAF=: graf
try.
  wd 'psel ',PForm
  pd_reset 'plotdemo'
  plotrun graf
  wd 'psel gedit'
catch.
  wdinfo 'error in graph definition'
  0 return.
end.
1
)

gedit_minus_button=: 3 : 0
1 >. GEDFONTSZ=: <:GEDFONTSZ
wd 'setfont graf ',GEDFONTSZ setfontsize GEDFONT
)

gedit_plus_button=: 3 : 0
GEDFONTSZ=: >:GEDFONTSZ
wd 'setfont graf ',GEDFONTSZ setfontsize GEDFONT
)
